TextUI (Java Platform SE 8 )
Keywords: javax.swing.plaf.TextUI class
Date: 2026-03-16

javax.swing.plaf

## Class TextUI

- java.lang.Object
- - javax.swing.plaf.ComponentUI
  - - javax.swing.plaf.TextUI

- Direct Known Subclasses:
    BasicTextUI, MultiTextUI

      public abstract class TextUI
      extends ComponentUI

  Text editor user interface

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `TextUI()`

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract void` | `damageRange(JTextComponent t, int p0, int p1)` Causes the portion of the view responsible for the given part of the model to be repainted.
    `abstract void` | `damageRange(JTextComponent t, int p0, int p1, Position.Bias firstBias, Position.Bias secondBias)` Causes the portion of the view responsible for the given part of the model to be repainted.
    `abstract EditorKit` | `getEditorKit(JTextComponent t)` Fetches the binding of services that set a policy for the type of document being edited.
    `abstract int` | `getNextVisualPositionFrom(JTextComponent t, int pos, Position.Bias b, int direction, Position.Bias[] biasRet)` Provides a way to determine the next visually represented model location that one might place a caret.
    `abstract View` | `getRootView(JTextComponent t)` Fetches a View with the allocation of the associated text component (i.e.
    `String` | `getToolTipText(JTextComponent t, Point pt)` Returns the string to be used as the tooltip at the passed in location.
    `abstract Rectangle` | `modelToView(JTextComponent t, int pos)` Converts the given location in the model to a place in the view coordinate system.
    `abstract Rectangle` | `modelToView(JTextComponent t, int pos, Position.Bias bias)` Converts the given location in the model to a place in the view coordinate system.
    `abstract int` | `viewToModel(JTextComponent t, Point pt)` Converts the given place in the view coordinate system to the nearest representative location in the model.
    `abstract int` | `viewToModel(JTextComponent t, Point pt, Position.Bias[] biasReturn)` Provides a mapping from the view coordinate space to the logical coordinate space of the model.

    - ### Methods inherited from class javax.swing.plaf.ComponentUI

      `contains, createUI, getAccessibleChild, getAccessibleChildrenCount, getBaseline, getBaselineResizeBehavior, getMaximumSize, getMinimumSize, getPreferredSize, installUI, paint, uninstallUI, update`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TextUI

          public TextUI()

  - ### Method Detail

    - #### modelToView

          public abstract Rectangle modelToView(JTextComponent t,
                                                int pos)
                                         throws BadLocationException

      Converts the given location in the model to a place in the view coordinate system.
      Parameters:
        `pos` - the local location in the model to translate >= 0
      Returns:
        the coordinates as a rectangle
      Throws:
        `BadLocationException` - if the given position does not represent a valid location in the associated document

    - #### modelToView

          public abstract Rectangle modelToView(JTextComponent t,
                                                int pos,
                                                Position.Bias bias)
                                         throws BadLocationException

      Converts the given location in the model to a place in the view coordinate system.
      Parameters:
        `pos` - the local location in the model to translate >= 0
      Returns:
        the coordinates as a rectangle
      Throws:
        `BadLocationException` - if the given position does not represent a valid location in the associated document

    - #### viewToModel

          public abstract int viewToModel(JTextComponent t,
                                          Point pt)

      Converts the given place in the view coordinate system to the nearest representative location in the model.
      Parameters:
        `pt` - the location in the view to translate. This should be in the same coordinate system as the mouse events.
      Returns:
        the offset from the start of the document >= 0

    - #### viewToModel

          public abstract int viewToModel(JTextComponent t,
                                          Point pt,
                                          Position.Bias[] biasReturn)

      Provides a mapping from the view coordinate space to the logical coordinate space of the model.
      Parameters:
        `pt` - the location in the view to translate. This should be in the same coordinate system as the mouse events.
        `biasReturn` - filled in by this method to indicate whether the point given is closer to the previous or the next character in the model
      Returns:
        the location within the model that best represents the given point in the view >= 0

    - #### getNextVisualPositionFrom

          public abstract int getNextVisualPositionFrom(JTextComponent t,
                                                        int pos,
                                                        Position.Bias b,
                                                        int direction,
                                                        Position.Bias[] biasRet)
                                                 throws BadLocationException

      Provides a way to determine the next visually represented model location that one might place a caret. Some views may not be visible, they might not be in the same order found in the model, or they just might not allow access to some of the locations in the model.
      Parameters:
        `t` - the text component for which this UI is installed
        `pos` - the position to convert >= 0
        `b` - the bias for the position
        `direction` - the direction from the current position that can be thought of as the arrow keys typically found on a keyboard. This may be SwingConstants.WEST, SwingConstants.EAST, SwingConstants.NORTH, or SwingConstants.SOUTH
        `biasRet` - an array to contain the bias for the returned position
      Returns:
        the location within the model that best represents the next location visual position
      Throws:
        `BadLocationException`
        `IllegalArgumentException` - for an invalid direction

    - #### damageRange

          public abstract void damageRange(JTextComponent t,
                                           int p0,
                                           int p1)

      Causes the portion of the view responsible for the given part of the model to be repainted.
      Parameters:
        `p0` - the beginning of the range >= 0
        `p1` - the end of the range >= p0

    - #### damageRange

          public abstract void damageRange(JTextComponent t,
                                           int p0,
                                           int p1,
                                           Position.Bias firstBias,
                                           Position.Bias secondBias)

      Causes the portion of the view responsible for the given part of the model to be repainted.
      Parameters:
        `p0` - the beginning of the range >= 0
        `p1` - the end of the range >= p0

    - #### getEditorKit

          public abstract EditorKit getEditorKit(JTextComponent t)

      Fetches the binding of services that set a policy for the type of document being edited. This contains things like the commands available, stream readers and writers, etc.
      Returns:
        the editor kit binding

    - #### getRootView

          public abstract View getRootView(JTextComponent t)

      Fetches a View with the allocation of the associated text component (i.e. the root of the hierarchy) that can be traversed to determine how the model is being represented spatially.
      Returns:
        the view

    - #### getToolTipText

          public String getToolTipText(JTextComponent t,
                                       Point pt)

      Returns the string to be used as the tooltip at the passed in location.
      Since:
        1.4
      See Also:
        `JTextComponent.getToolTipText(java.awt.event.MouseEvent)`

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2026, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.